SystemOrganization addCategory: #'Phidget-Core'!

!SequenceableCollection methodsFor: '*Phidget-Core' stamp: 'lk 6/16/2009 12:11'!
indexIsInRange: index

	^ index isInteger
		and: [ index >= 1 ]
		and: [ index <= self size ]! !

Object subclass: #PhdCrComponent
	instanceVariableNames: 'phidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

PhdCrComponent subclass: #PhdCrCompRFID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/15/2009 20:28'!
primGetLastTag: idArray

	<primitive: 'primGetLastRFIDTag' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/15/2009 20:28'!
primHasTag: idArray
	
	<primitive: 'primHasRFIDTag' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/15/2009 20:28'!
primIsAntennaOn: idArray
	"Answer true if the antenna is on, else false."
	
	<primitive: 'primIsRFIDAntennaOn' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/15/2009 20:28'!
primSetAntennaState: idArray to: state
	"Set the state of the antenna to on (state=1) or off (state=0)."
	
	<primitive: 'primSetRFIDAntennaState' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/15/2009 17:29'!
primSetSemaphoreIndexTagFound: semaphoreIndex for: idArray
	"registers the given semaphore to be signaled when a tag is found by the given Phidget."
	
	<primitive: 'primSetSemaphoreIndexRFIDTagFound' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID class methodsFor: 'primitives' stamp: 'lk 6/15/2009 17:29'!
primSetSemaphoreIndexTagLost: semaphoreIndex for: idArray
	"registers the given semaphore to be signaled when a tag is lost by the given Phidget."
	
	<primitive: 'primSetSemaphoreIndexRFIDTagLost' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:22'!
currentTag
	"Returns a string which represents a hex-value of the 5 bytes tag ID of the tag currently read.
	If there is no tag currently read, return nil."
	
	^ self hasTag
		ifTrue: [ self lastTag ]
		ifFalse: [ '' ]! !

!PhdCrCompRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:19'!
currentTagBytes
	"Returns a byte array with the 5 elements of the tag ID currently read.
	If there is no tag currently read, return nil."
	
	^ self hasTag
		ifTrue: [ self lastTagBytes ]
		ifFalse: [ nil ]! !

!PhdCrCompRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:25'!
hasTag
	"Returns true is a tag is currently connected and false if not."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class primHasTag: phidget id) == 1! !

!PhdCrCompRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:25'!
isAntennaOn
	"Answer true if the antenna is on, false otherwise."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class primIsAntennaOn: phidget id) == 1! !

!PhdCrCompRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:22'!
lastTag
	"Returns a string which represents a hex-value of the 5 bytes tag ID.
	This tag may or may not still be on the reader.
	If there was no tag read by the reader since opened, the method returns a string with 10 zeros."
	
	| aString bytes |
	aString := ''.
	bytes := self lastTagBytes.
	bytes ifNotNil: [
		bytes do: [ :byte | aString := aString , byte hex ] ].
	^ aString! !

!PhdCrCompRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:25'!
lastTagBytes
	"Returns a byte array with the 5 elements of the tag ID.
	This tag may or may not still be on the reader.
	If there was no tag read by the reader since opened, the method returns a Byte array with zeros."
	
	phidget isAttached ifFalse: [ ^ nil ].
	^ self class primGetLastTag: phidget id! !

!PhdCrCompRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:26'!
setAntennaState: aBoolean 
	"Sets the state of the antenna to true or false.
	The antenna must be enabled in order to find tags near the Phidget."
	
	| anInt |
	phidget isAttached ifFalse: [ ^ self ].
	aBoolean 
		ifTrue: [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ self class
		primSetAntennaState: phidget id
		to: anInt! !

PhdCrComponent subclass: #PhdCrCompSimpleLED
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompSimpleLED class methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 20:27'!
primIsOn: phid
	"Answer 1 if theLED is on, or other values otherwise."
	
	<primitive: 'primIsSimpleLEDOn' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompSimpleLED class methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 20:27'!
primSetState: idArray to: state
	"Set the state of the LED to true (state=1) or false (state=0)."
	
	<primitive: 'primSetSimpleLEDState' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompSimpleLED methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:49'!
isOn
	"Answer true if the LED is on, else false."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class primIsOn: phidget id) > 0! !

!PhdCrCompSimpleLED methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:50'!
setState: aBoolean 
	"Sets the state to true or false.
	true meens the LED is illuminated, false that it is not."
	
	| anInt |
	phidget isAttached ifFalse: [ ^ self ].
	aBoolean 
		ifTrue: [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ self class
		primSetState: phidget id
		to: anInt! !

!PhdCrComponent class methodsFor: 'instance creation' stamp: 'lk 6/1/2009 17:19'!
newWith: phidget

	^ self new
		setParent: phidget! !

!PhdCrComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 17:21'!
setParent: parent
	"Set my 'phidget' instance variable to the given one.
	If I already have a parent, do nothing."
	
	phidget ifNil: [ phidget := parent ].! !

PhdCrComponent subclass: #PhdCrMultiComponent
	instanceVariableNames: 'index nextLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

PhdCrMultiComponent subclass: #PhdCrCompAnalogSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompAnalogSensor class methodsFor: 'multi-component' stamp: 'lk 6/15/2009 14:47'!
primComponentCount: idArray
	"Gets the number of sensors for a phidget analog sensors component."

	<primitive: 'primNumAnalogSensors' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 14:39'!
primGetSensitivity: phidgetHandle at: index

	<primitive: 'primGetIntegerSensitivity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 21:53'!
primGetValue: phidgetHandle at: index
	"Gets the sensor value (0-1000) at the analog input with the given index."

	<primitive: 'primGetAnalogSensorValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 16:00'!
primSetSemaphoreIndexChange: semaphoreIndex for: idArray
	"registers the given Semaphore to be signaled when an sensor value changes on the given Phidget."
	
	<primitive: 'primSetSemaphoreIndexAnalogSensorChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 14:39'!
primSetSensitivity: phidgetHandle at: index to: anInteger

	<primitive: 'primSetIntegerSensitivity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:44'!
getSensitivity

	phidget isAttached ifFalse: [ ^ 0 ].
	^ self class
		primGetSensitivity: phidget id
		at: index - 1! !

!PhdCrCompAnalogSensor methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:44'!
setSensitivity: anInteger
	"Sets the sensor change trigger of the sensor to 'anInteger'.
	a sensor change block will only be evaluated if the change is more than this trigger."
	
	phidget isAttached ifFalse: [ ^ false ].
	(anInteger isInRange: (0 to: 100)) ifFalse: [ ^ false ].

	^ self class
		primSetSensitivity: phidget id
		at: index - 1
		to: anInteger! !

!PhdCrCompAnalogSensor methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:53'!
value
	"Gets the current value of the sensor (integer from 0 to 1000)."
	
	phidget isAttached ifFalse: [ ^ 0 ].
	^ self class
		primGetValue: phidget id
		at: index - 1! !

PhdCrMultiComponent subclass: #PhdCrCompDigitalInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompDigitalInput class methodsFor: 'multi-component' stamp: 'lk 6/15/2009 15:00'!
primComponentCount: phidgetHandle
	"Gets the number of inputs for a phidget digital input component."

	<primitive: 'primNumDigitalInputs' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompDigitalInput class methodsFor: 'primitives' stamp: 'lk 6/15/2009 21:54'!
primGetValue: phidgetHandle at: index
	"Gets the input value (0/1 = on/off) at the digital input with the given index."

	<primitive: 'primGetDigitalInputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalInput class methodsFor: 'primitives' stamp: 'lk 6/15/2009 16:00'!
primSetSemaphoreIndexChange: semaphoreIndex for: idArray
	"registers the given Semaphore to be signaled when an input value changes on the given Phidget."
	
	<primitive: 'primSetSemaphoreIndexDigitalInputChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalInput methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:54'!
value
	"Gets the current value of the input (true/false = on/off)."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class
		primGetValue: phidget id
		at: index - 1) > 0! !

PhdCrMultiComponent subclass: #PhdCrCompDigitalOutput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompDigitalOutput class methodsFor: 'multi-component' stamp: 'lk 6/15/2009 13:17'!
primComponentCount: phidgetHandle
	"Gets the number of outputs for a phidget digital output component."

	<primitive: 'primNumDigitalOutputs' module: 'PhidgetPlugin'>
	^ 0! !

!PhdCrCompDigitalOutput class methodsFor: 'primitives' stamp: 'lk 6/1/2009 20:31'!
primGetValue: phidgetHandle at: index
	"Gets the output value (0/1 = on/off) at the digital output with the given index."

	<primitive: 'primGetDigitalOutputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalOutput class methodsFor: 'primitives' stamp: 'lk 6/15/2009 16:00'!
primSetSemaphoreIndexChange: semaphoreIndex for: idArray
	"registers the given Semaphore to be signaled when an output value changes on the given Phidget."
	
	<primitive: 'primSetSemaphoreIndexDigitalOutputChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalOutput class methodsFor: 'primitives' stamp: 'lk 6/1/2009 20:34'!
primSetValue: phidgetHandle at: index to: value
	"Sets the output value (0/1 = on/off) at the digital output with the given index to the given value."

	<primitive: 'primSetDigitalOutputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalOutput methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:45'!
value
	"Gets the current value of the output (true/false = on/off)."
	
	phidget isAttached ifFalse: [ ^ false ].
	^ (self class
		primGetValue: phidget id
		at: index - 1) > 0! !

!PhdCrCompDigitalOutput methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:45'!
value: aBoolean
	"Sets the current value of the output (true = on, false = off)."
	
	| number |
	phidget isAttached ifFalse: [ ^ false ].
	aBoolean
		ifTrue: [ number := 1 ]
		ifFalse: [ number := 0 ].
	^ self class
		primSetValue: phidget id
		at: index - 1
		to: number! !

PhdCrMultiComponent subclass: #PhdCrCompServoMotor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompServoMotor class methodsFor: 'multi-component' stamp: 'lk 6/15/2009 21:33'!
primComponentCount: idArray
	"Gets the number of servo motors for a (simple) servo motor component."

	<primitive: 'primNumServoMotors' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 22:12'!
primGetMaxPosition: idArray at: index
	"Returns a float containing max. possible position of the motor at the given index."

	<primitive: 'primGetServoPositionMax' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 22:13'!
primGetMinPosition: phid at: index
	"Returns a float containing min. possible position of the motor at the given index."

	<primitive: 'primGetServoPositionMin' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 22:06'!
primGetPosition: idArray at: index
	"Returns a float containing the position of the motor at the given index."

	<primitive: 'primGetServoPosition' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 22:14'!
primIsEngaged: idArray at: index
	"Returns 1 if the motor on the given index is engaged - otherwise return 0.
	This is whether the motor is powered or not."

	<primitive: 'primIsServoEngaged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/16/2009 12:00'!
primSetEngaged: idArray at: index to: value
	"Sets the engagement state of the motor at the given index. Value must be 0 or 1.
	This is whether the motor is powered or not."

	<primitive: 'primSetServoEngaged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 22:11'!
primSetPosition: idArray at: index to: aFloat
	"Set the position of the motor at the given index to aFloat. aFloat must be between primGetPositionMin and primGetPositionMax."

	<primitive: 'primSetServoPosition' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor class methodsFor: 'primitives' stamp: 'lk 6/15/2009 22:15'!
primSetSemaphoreIndexPositionChange: semaphoreIndex for: idArray
	"registers the given Semaphore to be signaled when a motor changes its position."
	
	<primitive: 'primSetSemaphoreIndexServoPositionChange' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompServoMotor methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:46'!
isEngaged
	"Returns the engaged state of the motor. This is whether the motor is powered or not."
	
	phidget isAttached ifFalse: [ ^ self ].
	^ (self class
		primIsEngaged: phidget id
		at: index - 1) == 1! !

!PhdCrCompServoMotor methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 23:16'!
position
	"Returns the current position of the motor."
	
	| result |
	phidget isAttached ifFalse: [ ^ 0.0 ].
	result := self class
		primGetPosition: phidget id
		at: index - 1.
	^ result
		ifNotNil: [ result ]
		ifNil: [ 0.0 ]! !

!PhdCrCompServoMotor methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 22:10'!
position: aValue
	"Set the position of the motor..
	aValue should be a number betwenn the min. and max. motor position."
	
	| aFloat |
	phidget isAttached ifFalse: [ ^ false ].
	aFloat := aValue asFloat.
	(self positionIsInRange: aFloat) ifFalse: [ ^ false ].
	^ (self class
		primSetPosition: phidget id
		at: index - 1
		to: aFloat) == 1! !

!PhdCrCompServoMotor methodsFor: 'as yet unclassified' stamp: 'lk 6/16/2009 11:58'!
positionIsInRange: position
	"The position is in range, if the position is between the min. and max. position."
	
	phidget isAttached ifFalse: [ ^ false ].
	self positionMin <= position ifFalse: [ ^ false ].
	self positionMax >= position ifFalse: [ ^ false ].
	^ true! !

!PhdCrCompServoMotor methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 23:16'!
positionMax
	"Returns the max. allowed motor position for this motor."
	
	| result |
	phidget isAttached ifFalse: [ ^ 0.0 ].
	result := self class
		primGetMaxPosition: phidget id
		at: index - 1.
	^ result
		ifNotNil: [ result ]
		ifNil: [ 0.0 ]! !

!PhdCrCompServoMotor methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 23:17'!
positionMin
	"Returns the min. allowed motor position for this motor."
	
	| result |
	phidget isAttached ifFalse: [ ^ 0.0 ].
	result := self class
		primGetMinPosition: phidget id
		at: index - 1.
	^ result
		ifNotNil: [ result ]
		ifNil: [ 0.0 ]! !

!PhdCrCompServoMotor methodsFor: 'as yet unclassified' stamp: 'lk 6/16/2009 12:00'!
setEngaged: aBoolean
	"Sets the engaged state of a motor. This is whether the motor is powered or not."
	
	| anInt |
	phidget isAttached ifFalse: [ ^ false ].
	aBoolean 
		ifTrue: [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ (self class
		primSetEngaged: phidget id
		at: index - 1
		to: anInt) == 1! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/15/2009 13:17'!
componentCount: phidget
	"Returns the number of components in a multicomponent phidget.
	Uses a primitive the subclasses must define. This primitive can for example call GetNumSensors in an InterfaceKit."
	
	phidget isAttached ifTrue: [ | result |
		result := self primComponentCount: phidget id.
		result ifNil: [ ^ 0 ].
		^ result ].
	 ^ 0! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/1/2009 18:40'!
getListFor: phidget
	"Answers a LinkedList of my class, with self componentCount elements each initialized with its index in the list."

	| list size |
	list := LinkedList new.
	size := self componentCount: phidget.
	
	(1 to: size) do: [ :i |
		list add: (self newWith: phidget index: i) ].
	^ list! !

!PhdCrMultiComponent class methodsFor: 'instance creation' stamp: 'lk 6/1/2009 18:19'!
newWith: phidget index: index

	^ (self newWith: phidget)
		setIndex: index! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/1/2009 18:26'!
primComponentCount: phidgetHandle
	"Gets the number of components for a phidget multi component."

	self subclassResponsibility.! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:38'!
nextLink

	^ nextLink! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:38'!
nextLink: aMultiComponent

	nextLink := aMultiComponent.! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:17'!
setIndex: aNumber
	"Set my 'index' instance variable to the given one.
	If I already have an index, do nothing."
	
	index ifNil: [ index := aNumber ].! !

Object subclass: #PhdCrPhidget
	instanceVariableNames: 'opened semaphores userProcessBlocks id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

PhdCrPhidget class
	instanceVariableNames: 'SystemCallbacks'!

!PhdCrPhidget commentStamp: 'lk 6/1/2009 17:09' prior: 0!
I am an abstract class that provides some primitives and methods for Phidget support. Please read the comments of my subclasses to find more information how to use Phidgets in Squeak.

Instance Variables
	handle:					<ByteArray>
	opened:					<Boolean>
	userProcessBlocks:	<Dictionary> (Symbol -> Block)
	semaphores:				<Dictionary> (Symbol -> Semaphore)
Class Instance Variables
	SystemCallback:		<Dictionary> (Symbol -> Symbol)
	
handle
	- a ByteArray that contains the Phidget handle for the C API. Every primitive (except the one where the handle is created) needs this ByteArray to let the C API know about which Phidget it is currently talking.

opened
	- true, if the Phidget was opened - Squeak is able to communicate with the hardware. This does not mean there is a Phidget attached.
	- false, if the Phidgets was not opened or was opened and then closed.

semaphores
	- A Dictionary with entries of the following form: aSymbol -> aSemaphore.
	aSymbol may be #Attach, #Detach, #Error for Phidgets in general. Other symbols may exist for phidget specific support in my subclasses. My classes method 'knownCallback' answers a list of callbacks I know.
	I use this dictionary to handle the callbacks from the Phidget C API.
	These semaphores can be registered for certain events (like the attach event) - so that the C API signals is if the event occours. These semaphores are used in my callbackProcess method.

userProcessBlocks
	- a Dictionary with entries of the following form: aSymbol -> aBlock.
	The symbols are equivalent to the symbols used in the semaphores dictionary.
	I use this dictionary to handle the callbacks from the Phidget C API.
	Each time a semaphore from the semaphores dictionary was signaled from the C API, I evaluate the corresponding block from this dictionary in the callbackProcess method.

SystemCallbacks
	My class has a method called 'systemCallbacks'. This Dictionary is similar to the userProcessBlocks: It maps from callbackNames to message selectors. Those messages willbe sent when the semaphore at 'callbackName' is signaled.
	In contrast to userProcessBlocks this Dictionary is immutable to the user. Currently it is only used for initializing and deleting phidget components an attaching/detaching (see below).

About Components:
	A phidget can have several components, e.g. a List of outputs or a LED. Those components derive from the PhdCrComponent class. See its documentation to lern more about them.
	When a phidget is attached, it initializes its components using 'initializeComponents'. When the phidget is detached or closed, 'deleteComponents' deletes them again.
	As there are different Phidgets per phidget class, the components can differ. A InterfaceKit can for instance have 8 sensors, others might have none. The implementation of initializeComponents must be aware of that.
	!

PhdCrPhidget class
	instanceVariableNames: 'SystemCallbacks'!

PhdCrPhidget subclass: #PhdCrInterfaceKit
	instanceVariableNames: 'sensors inputs outputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrInterfaceKit commentStamp: 'lk 6/1/2009 17:12' prior: 0!
I am a representation of a Phidget called 'Interface Kit' in Squeak.
To use a Interface Kit, create a new instance and open a connection to the hardware board with:
	ifKit := PhdCrInterfaceKit new.
	ifKit openAny.
Send me a block to be evaluated every time the hardware board was attached, detached, an error occoured, a sensor value was changed, an input value was changed or an output value was changed. For example:
	ifKit
		onAttachDo: [ Transcript show:'servo was attached!!;cr' ];
		onDetachDo: [ Transcript show:'servo was detached!!;cr' ];
		onSensorChangeDo: [ Transcript show:'A sensor changed it's value!!' ].

Depending on which hardware is attached it is possible to attach zero or more analog sensors (, digital inputs or digital outputs) to the board. To get the number of available sensors send 'sensorCount' ('inputCount', 'outputCount'). Every sensor can be accessed by an index adressing it. Valid indices are greater or equal than 1 and less or equal than the number of available sensors (sensorCount).
To get the value of a sensor, call 'sensorValue: index'. The value will be a number between 0 and 1000.
The input and output values are boolean and may be read by: 'outputValue: index' or 'inputValue: index'.
Set an output value to true/false with 'setOutputValue: aBoolean at: index'.

IMPORTANT:
After using the Interface Kit it is important to close the connection to the hardware by sending 'close':
	ifKit close.

NOTE:
The block for onSensorChange will be evaluated only if the change is greater than a number called sensitivity. Example: A light sensor probably changes its value continuously. We want to know greater changes only, so we set the sensitivity to 50. So the sensor change block will be evaluated only if the change is greater than 50. To set the sensitivity, call 'sensitivity: aNumber to: index'.
!

!PhdCrInterfaceKit class methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:23'!
knownCallbacks
	"Returns a list of callback names (#symbols) the InterfaceKit knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #SensorChange #InputChange #OutputChange )! !

!PhdCrInterfaceKit class methodsFor: 'primitives' stamp: 'lk 6/15/2009 17:14'!
primCreate
	"Create a new the Interface Kit object. Returns a new id for the Phidget."

	<primitive: 'primInterfaceKitCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 13:36'!
deleteComponents
	"This method is called when the InterfaceKit is detached. It delets previously in 'initializeComponents' built components: sensors, inputs, outputs."

	sensors := LinkedList new.
	inputs := LinkedList new.
	outputs := LinkedList new.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 16:15'!
initialize

	super initialize.
	
	inputs := LinkedList new.
	outputs := LinkedList new.
	sensors := LinkedList new.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 14:59'!
initializeComponents
	"This method is called when an InterfaceKit is attached. It initializes its components: sensors, inputs, outputs.
	The components will be deleted in 'deleteComponents' on detaching."
	
	sensors := PhdCrCompAnalogSensor getListFor: self.
	inputs := PhdCrCompDigitalInput getListFor: self.
	outputs := PhdCrCompDigitalOutput getListFor: self.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 16:13'!
inputs
	^ inputs! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 16:13'!
outputs
	^ outputs! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 16:07'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding semaphores for #SensorChange, #InputChange and #OutputChange."
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #SensorChange).
	PhdCrCompAnalogSensor
		primSetSemaphoreIndexChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #InputChange).
	PhdCrCompDigitalInput
		primSetSemaphoreIndexChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #OutputChange).
	PhdCrCompDigitalOutput
		primSetSemaphoreIndexChange: semaIndex
		for: id.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 16:14'!
sensors
	^ sensors! !

!PhdCrPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:23'!
knownCallbacks
	"Returns a list of callback names (#symbols) the Phidget knows"
	
	^ #( #Attach #Detach #Error )! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 13:11'!
lastError
	"Returns the error code of the last error.
	Descriptions of the codes may be found on www.phidgets.com or phidget21.h in line 2250 ff."

	^ self primLastError! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 14:14'!
primClose: idArray
	"Close the Phidget with given id."
	
	<primitive: 'primClose' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 13:02'!
primIsAttached: idArray
	"Returns 1 if the Phidget is attached, and other values otherwise."
	
	<primitive: 'primIsAttached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 13:02'!
primIsValid: idArray
	"Returns 1 if the Phidget id is valid, or other values otherwise."
	
	<primitive: 'primIsValid' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 13:10'!
primLastError
	"Returns the error code of the last error.
	Descriptions of the codes may be found on www.phidgets.com or phidget21.h in line 2250 ff."

	<primitive: 'primLastError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 14:14'!
primOpen: idArray withSerial: serial
	"Opens the Phidget with the given serial number"

	<primitive: 'primOpen' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 12:44'!
primSetSemaphoreIndexAttach: semaphoreIndex for: idArray
	"registers the given Semaphore to be signaled when the Phidget with given id is attached."
	
	<primitive: 'primSetSemaphoreIndexAttach' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 12:33'!
primSetSemaphoreIndexDetach: semaphoreIndex for: idArray
	"registers the given Semaphore to be signaled when the Phidget with given id is attached."
	
	<primitive: 'primSetSemaphoreIndexDetach' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'primitives' stamp: 'lk 6/15/2009 12:31'!
primSetSemaphoreIndexError: semaphoreIndex for: idArray
	"registers the given Semaphore to be signaled when the Phidget with given id is attached."
	
	<primitive: 'primSetSemaphoreIndexError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 17:04'!
systemCallbacks
	"This Method answers a Doctionary similar to the instance's userProcessBlocks.
	It may for instance contain message selectors sent when attaching or detaching a phidget, so the phidget components can be initialized."
	
	SystemCallbacks ifNotNil: [ ^ SystemCallbacks ].
	
	SystemCallbacks := Dictionary new.
	SystemCallbacks
		add: #Attach -> #initializeComponents;
		add: #Detach -> #deleteComponents.
	^ SystemCallbacks! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 13:47'!
callbackProcess: callbackName 
	"This method will be forked as an extra process for every callback that a phidget needs.
	The semaphores were previously initialised and registered as external objects.
	self class knownCallbacks lists all possible semaphore names.
	systemCallbacks contain message selectors to be sent."
	
	(semaphores at: callbackName) wait.
	[ self isOpen ] whileTrue: [
		(self class systemCallbacks includesKey: callbackName) 
			ifTrue: [ self perform: (self class systemCallbacks at: callbackName) ].
		(userProcessBlocks at: callbackName) value.
		(semaphores at: callbackName) wait ]! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 13:46'!
checkValid
	"Checks if the Phidgets has an id and if this id is valid."

	^ id isNil not and: [ | result |
		result := (self class primIsValid: id) == 1.
		result ifFalse: [
			"this may have happened if a Phidget was created and then the image was saved,
			closed and reloaded. The hardware connection is broken. We need to make this
			instance fully invalid."
			id := nil.
			self close ].
		result ]! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 14:14'!
close
	"Close the Phidget."
	self isOpen ifFalse: [ ^ self ].	"already closed"
	self class primClose: id.
	opened := false.
	self
		unregisterSemaphores;
		deleteComponents! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 00:47'!
createCallbackProcessBlock: callbackName
	"Create a callback process block to be forked.
	Must be swapped out to work in loops."

	^ [ self callbackProcess: callbackName ]! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:41'!
deleteComponents
	"This method is called when a Phidget is detached. It should delete previously in 'initializeComponents' built components, e.g. outputs, sensors, ...
	The abstract phidget does not have components, so it does nothing here."! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:05'!
forkCallbacks
	"Fork the callback processes."
	
	self class knownCallbacks do: [ :callbackName |
		(self createCallbackProcessBlock: callbackName) fork ].! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 11:24'!
id
	^ id! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 14:16'!
initialize
	"Initialise the callbacks that are used in every Phidget.
	Every subclass should call super initialise or initialise the callbacks by their own.
	In addition mark phidget as opened and create the representation in the plugin using a primitive."
	
	super initialize.
	semaphores := Dictionary new.
	userProcessBlocks := Dictionary new.
	self class knownCallbacks do: 
		[ :name | 
		semaphores add: name -> Semaphore new.
		userProcessBlocks add: name -> [  ] ].
	opened := false.
	id := self class primCreate.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:41'!
initializeComponents
	"This method is called when a Phidget is attached. It should initialize its components (sensors, outputs, ...).
	The components will be deleted in 'deleteComponents' on detaching.
	The abstract phidget does not have components, so it does nothing here."! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 20:34'!
isAttached
	"Returns true if the Phidget is attached, and false otherwise."

	^ self checkValid & opened and: [ (self class primIsAttached: id) == 1 ]! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 13:08'!
isOpen

	^ self checkValid and: [ opened ]! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 19:09'!
on: callbackName do: aBlock 
	"aBlock will be evaluated when the semaphore at callbackName is signaled."
	
	(self class knownCallbacks includes: callbackName) ifTrue: [
		userProcessBlocks 
			at: callbackName
			put: aBlock ].! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 13:09'!
openAny
	"opens hardware connection to any phidget with matching class."

	^ self openWithSerial: -1! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 14:09'!
openWithSerial: serialNumber 
	"Opens the Phidget with the given serial number.
	Opens any Phidgets of matching class if serialNumber is -1."

	(self checkValid and: [self isOpen not]) ifFalse: [ ^ self ].
	self registerSemaphores.
	self class
		primOpen: id
		withSerial: serialNumber.
	opened := true.
	self forkCallbacks.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 11:57'!
primCreate
	"Reset the Phidget (Semaphores and Handle)."
	
	self subclassResponsibility.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 12:32'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. May be extended in subclasses."
	
	| semaIndex |
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #Attach).
	self class
		primSetSemaphoreIndexAttach: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #Detach).
	self class
		primSetSemaphoreIndexDetach: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #Error).
	self class
		primSetSemaphoreIndexError: semaIndex
		for: id.! !

!PhdCrPhidget methodsFor: 'testing' stamp: 'lk 6/15/2009 11:23'!
testSemaphoresReset
	"Answer true if the semaphores are reset, false otherwise."
	id do: [ :byte | byte isZero ifFalse: [ ^ false ] ].
	^ true! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'pt 5/2/2009 22:16'!
unregisterSemaphores
	"Unregister the semaphores which were previously registered with 'self registerSemaphores'."

	semaphores do: [ :sema |
		sema signal.
		Smalltalk unregisterExternalObject: sema ]! !

PhdCrPhidget subclass: #PhdCrRFID
	instanceVariableNames: 'rfid led outputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrRFID commentStamp: 'lk 6/1/2009 17:12' prior: 0!
I am a representation of a Phidget called 'Phidget RFID' in Squeak.
To use the RFID Phidget, create a new instance and open a connection to the hardware board with:
	rfid := PhdCrRFID new.
	rfid openAny.
A block can be set to be evaluated every time the hardware board was attached, detached, an error occoured, an output value was changed, a tag was found by the RFID reader, or if the tag was lost. For example:
	rfid
		onAttachDo: [ Transcript show:'rfid was attached!!';cr ];
		onDetachDo: [ Transcript show:'rfid was detached!!';cr ];
		onTagFoundDo: [ Transcript show:'rfid found a tag';cr ].

The RFID antenna is needed to read tags near the Phidget. Send 'setAntennaState: true' to turn it on (false to turn it off).
To get a tag currently read by the reader send 'getCurrentTag' or 'getCurrentTagBytes' (latter will give you an array identifying the tag, first will give you a string of hexadecimal values representing the array). You can also find out which tag was read last without regard if it is still read. Use 'getLastTag' or 'getLastTagBytes'.
To illuminate the on-board LED send 'setLedState: true', (false to turn off). You can get the current state of the LED by sending 'isLedOn'.
Depending on which hardware is attached it is possible to attach zero or more digital outputs to the board. To get the number of available outputs send 'outputCount'. Every output can be accessed by an index adressing it. Valid indices are greater or equal than 1 and less or equal than the number of available outputs (outputCount).
The output values are boolean and may be read by: 'outputValue: index'. Set an output value to true/false with 'setOutputValue: aBoolean at: index'.

IMPORTANT:
After using the RFID Phidget it is important to close the connection to the hardware by sending 'close':
	rfid close.

NOTE:
The antenna might be enabled/disabled from the last use of the Phidget. If you do not get a signal, test the antenna state.

NICE EXAMPLE ;) (indicating if a tag was found using the LED)
	rfid := PhdCrRFID new.
	rfid
		onAttachDo: [ rfid setAntennaState: true ];
		onTagFoundDo: [ rfid setLedState: true ];
		onTagLostDo: [ rfid setLedState: false ];
		openAny.
	"Now hold a tag near the Phidget and then take it away."
	rfid close.!

!PhdCrRFID class methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:03'!
knownCallbacks
	"Returns a list of callback names (#symbols) the RFID Phidget knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #OutputChange #TagFound #TagLost )! !

!PhdCrRFID class methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:18'!
primCreate
	"Create a new the RFID object. Returns a new id for the Phidget."

	<primitive: 'primRFIDCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 20:31'!
deleteComponents
	"This method is called when the RFID Phidget is detached. It delets previously in 'initializeComponents' built components: outputs"

	outputs := LinkedList new.! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:41'!
initialize

	super initialize.
	
	rfid := PhdCrCompRFID newWith: self.
	led := PhdCrCompSimpleLED newWith: self.
	outputs := LinkedList new.! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 20:31'!
initializeComponents
	"This method is called when a RFID Phidget is attached. It initializes its components:  outputs.
	The components will be deleted in 'deleteComponents' on detaching."

	outputs := PhdCrCompDigitalOutput getListFor: self.! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:21'!
led
	^ led! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 16:15'!
outputs
	^ outputs! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 17:31'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding semaphores for #OutputChange, #TagFound and #TagLost."
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #OutputChange).
	PhdCrCompDigitalOutput
		primSetSemaphoreIndexChange: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #TagFound).
	PhdCrCompRFID
		primSetSemaphoreIndexTagFound: semaIndex
		for: id.
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #TagLost).
	PhdCrCompRFID
		primSetSemaphoreIndexTagLost: semaIndex
		for: id.! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:20'!
rfidSensor
	^ rfid! !

PhdCrPhidget subclass: #PhdCrServo
	instanceVariableNames: 'motors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrServo commentStamp: 'lk 6/1/2009 17:12' prior: 0!
I am a representation of a Phidget called 'Servo' (here: 'Servo board') in Squeak.
To use the Servo board, create a new instance and open a connection to the hardware board with:
	servo := PhdCrServo new.
	servo openAny.
A block can be set to be evaluated every time the hardware board was attached, detached, an error occoured or the position of a motor was changed. For example:
	servo
		onAttachDo: [ Transcript show:'servo was attached!!;cr' ];
		onDetachDo: [ Transcript show:'servo was detached!!;cr' ];
		onPositionChangeDo: [ Transcript show:'A motor changed it's position!!' ].
Depending on which hardware is attached it is possible to attach one or more servo motors to the board. To get the number of available motors send 'motorCount'. Every motor can be accessed by an index adressing the motor. Valid indices are greater or equal than 1 and less or equal than the number of available motors (motorCount).
To set the position of a motor to a value, call 'setMotorPosition: aFloat at: index' (aFloat must be between minMotorPositionAt: index and maxMotorPositionAt: index !!).

IMPORTANT:
After using the servo it is important to close the connection to the hardware by sending 'close':
	servo close.
!

!PhdCrServo class methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:23'!
knownCallbacks
	"Returns a list of callback names (#symbols) the Servo knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #PositionChange )! !

!PhdCrServo class methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:42'!
primCreate
	"Create a new the Servo object. Returns a new id for the Phidget."

	<primitive: 'primServoCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:40'!
deleteComponents
	"This method is called when the Phidget is detached. It resets previously in 'initializeComponents' built components: motors"

	motors := LinkedList new.! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:42'!
initialize

	super initialize.
	
	motors := LinkedList new.! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:41'!
initializeComponents
	"This method is called when the Phidget is attached. It initializes its components:  motots.
	The components will be reset in 'deleteComponents' on detaching."

	motors := PhdCrCompServoMotor getListFor: self.! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 21:37'!
motors
	^ motors! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 6/15/2009 22:16'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding a semaphore for #PositionChange."
	
	| semaIndex |
	super registerSemaphores.
	
	semaIndex := Smalltalk registerExternalObject: (semaphores at: #PositionChange).
	PhdCrCompServoMotor
		primSetSemaphoreIndexPositionChange: semaIndex
		for: id.! !
